import { InjectionToken, Injector } from '@angular/core';
import { OktaAuthService } from '../services/okta.service';
export declare type AuthRequiredFunction = (oktaAuth: OktaAuthService, injector: Injector) => void;
export declare type IsAuthenticatedFunction = () => Promise<boolean>;
export declare type OnSessionExpiredFunction = () => void;
export interface TestingObject {
    disableHttpsCheck: boolean;
}
export interface TokenManagerConfig {
    autoRenew?: boolean;
    secure?: boolean;
    storage?: string;
}
export interface OktaConfig {
    issuer?: string;
    redirectUri?: string;
    clientId?: string;
    scope?: string;
    scopes?: string[];
    responseType?: any;
    pkce?: boolean;
    onAuthRequired?: AuthRequiredFunction;
    testing?: TestingObject;
    tokenManager?: TokenManagerConfig;
    postLogoutRedirectUri?: string;
    isAuthenticated?: IsAuthenticatedFunction;
    onSessionExpired?: OnSessionExpiredFunction;
}
export declare const OKTA_CONFIG: InjectionToken<OktaConfig>;
